Index: /branches/PluginInfrastructure Refactoring/ALGLIB/AlglibPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/ALGLIB/AlglibPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/ALGLIB/AlglibPlugin.cs	(revision 2587)
@@ -27,7 +27,7 @@
 
 namespace ALGLIB {
-  [ClassInfo(Name = "ALGLIB")]
-  [PluginFile(Filename = "ALGLIB.dll", Filetype = PluginFileType.Assembly)]
-  [PluginFile(Filename = "ALGLIB License.txt", Filetype = PluginFileType.License)]
+  [Plugin("ALGLIB")]
+  [PluginFile("ALGLIB.dll", PluginFileType.Assembly)]
+  [PluginFile("ALGLIB License.txt", PluginFileType.License)]
   public class AlgLibPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/AvailableOperatorsForm.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/AvailableOperatorsForm.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/AvailableOperatorsForm.cs	(revision 2587)
@@ -63,13 +63,10 @@
       builtinOperatorsTreeView.TreeViewNodeSorter = nodeSorter;
 
-      DiscoveryService discoveryService = new DiscoveryService();
-      PluginInfo[] plugins = discoveryService.Plugins;
-      foreach(PluginInfo plugin in plugins) {
+      foreach(IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
         TreeNode pluginItem = new TreeNode();
         pluginItem.Text = plugin.Name;
         pluginItem.Tag = plugin;
 
-        Type[] operators = discoveryService.GetTypes(typeof(IOperator), plugin);
-        foreach(Type type in operators) {
+        foreach (Type type in ApplicationManager.Manager.GetTypes(typeof(IOperator), plugin)) {
           if(!type.IsAbstract) {
             TreeNode operatorItem = new TreeNode();
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/HeuristicLabAdvancedOptimizationFrontendApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/HeuristicLabAdvancedOptimizationFrontendApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/HeuristicLabAdvancedOptimizationFrontendApplication.cs	(revision 2587)
@@ -30,5 +30,5 @@
   /// The HeuristicLab Advanced Optimization Frontend Application.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab 3.2 (dockable)", Description="Next generation heuristic optimization environment.")]
+  [Application("HeuristicLab 3.2 (dockable)", "Next generation heuristic optimization environment.")]
   class HeuristicLabAdvancedOptimizationFrontendApplication : ApplicationBase {
     /// <summary>
@@ -37,5 +37,5 @@
     public override void Run() {
       Form mainForm = new MainForm();
-      PluginManager.ControlManager = (IControlManager)mainForm;
+      ControlManager.RegisterManager((IControlManager)mainForm);
       Application.Run(mainForm);
     }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/HeuristicLabAdvancedOptimizationFrontendPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/HeuristicLabAdvancedOptimizationFrontendPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/HeuristicLabAdvancedOptimizationFrontendPlugin.cs	(revision 2587)
@@ -30,8 +30,8 @@
   /// Plugin class for HeuristicLab.AdvancedOptimizationFrontend plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.AdvancedOptimizationFrontend-3.2")]
-  [PluginFile(Filename = "HeuristicLab.AdvancedOptimizationFrontend-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.MainForm.WindowsForms-3.2")]
+  [Plugin("HeuristicLab.AdvancedOptimizationFrontend-3.2")]
+  [PluginFile("HeuristicLab.AdvancedOptimizationFrontend-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms-3.2")]
   public class HeuristicLabAdvancedOptimizationFrontendPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/MainForm.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/MainForm.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.AdvancedOptimizationFrontend/3.2/MainForm.cs	(revision 2587)
@@ -26,4 +26,5 @@
 using System.Drawing;
 using System.Text;
+using System.Linq;
 using System.Threading;
 using System.Windows.Forms;
@@ -68,12 +69,8 @@
       form.Show(dockPanel);
 
-      DiscoveryService discoveryService = new DiscoveryService();
-
       // discover creatable items
-      Type[] creatables = discoveryService.GetTypes(typeof(IEditable));
-      string[] names = new string[creatables.Length];
-      for (int i = 0; i < creatables.Length; i++)
-        names[i] = creatables[i].Name;
-      Array.Sort(names, creatables);
+      var creatables = from x in ApplicationManager.Manager.GetTypes(typeof(IEditable))
+                       orderby x.Name
+                       select x;      
       foreach (Type type in creatables) {
         if (!type.IsAbstract) {
@@ -100,6 +97,6 @@
     /// is neither a view nor an editor.</exception>
     /// <param name="control">The control to display.</param>
-    public void ShowControl(IControl control) {
-      if (InvokeRequired) Invoke((Action<IControl>)ShowControl,control);
+    public void ShowControl(object control) {
+      if (InvokeRequired) Invoke((Action<object>)ShowControl, control);
       else {
         DockContent content;
@@ -132,5 +129,5 @@
         saveAllToolStripButton.Enabled = true;
         EditorForm form = ActiveMdiChild as EditorForm;
-        if (form != null){
+        if (form != null) {
           if (((Control)form.Editor).Enabled) {
             saveToolStripMenuItem.Enabled = true;
@@ -158,9 +155,11 @@
       try {
         task.storable = PersistenceManager.Load(task.filename);
-      } catch(FileNotFoundException fileNotFoundEx) {
+      }
+      catch (FileNotFoundException fileNotFoundEx) {
         MessageBox.Show("Sorry couldn't open file \"" + task.filename + "\".\nThe file or plugin \"" + fileNotFoundEx.FileName + "\" is not available.\nPlease make sure you have all necessary plugins installed.",
           "Reader Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
-      } catch(TypeLoadException typeLoadEx) {
-        MessageBox.Show("Sorry couldn't open file \"" + task.filename + "\".\nThe type \"" + typeLoadEx.TypeName+ "\" is not available.\nPlease make sure that you have the correct version the plugin installed.",
+      }
+      catch (TypeLoadException typeLoadEx) {
+        MessageBox.Show("Sorry couldn't open file \"" + task.filename + "\".\nThe type \"" + typeLoadEx.TypeName + "\" is not available.\nPlease make sure that you have the correct version the plugin installed.",
           "Reader Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
       }
@@ -183,5 +182,5 @@
           editor.Filename = task.filename;
           editor.SaveFinished += new EventHandler(SaveFinished);
-          PluginManager.ControlManager.ShowControl(editor);
+          ControlManager.Manager.ShowControl(editor);
         }
         lock (locker) {
@@ -239,5 +238,5 @@
         } else {
           editor.SaveFinished += new EventHandler(SaveFinished);
-          PluginManager.ControlManager.ShowControl(editor);
+          ControlManager.Manager.ShowControl(editor);
           EnableDisableItems();
         }
@@ -298,5 +297,5 @@
       for (int i = 0; i < MdiChildren.Length; i++) {
         EditorForm form = MdiChildren[i] as EditorForm;
-        if (form!=null && ((Control)form.Editor).Enabled) Save(form);
+        if (form != null && ((Control)form.Editor).Enabled) Save(form);
       }
     }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.ArtificialNeuralNetworks/3.2/HeuristicLabArtificialNeuralNetworksPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.ArtificialNeuralNetworks/3.2/HeuristicLabArtificialNeuralNetworksPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.ArtificialNeuralNetworks/3.2/HeuristicLabArtificialNeuralNetworksPlugin.cs	(revision 2587)
@@ -25,16 +25,16 @@
 
 namespace HeuristicLab.ArtificialNeuralNetworks {
-  [ClassInfo(Name = "HeuristicLab.ArtificialNeuralNetworks-3.2")]
-  [PluginFile(Filename = "HeuristicLab.ArtificialNeuralNetworks-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "ALGLIB")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators.Programmable-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Selection-3.2")]
-  [Dependency(Dependency = "HeuristicLab.SequentialEngine-3.2")]
+  [Plugin("HeuristicLab.ArtificialNeuralNetworks-3.2")]
+  [PluginFile("HeuristicLab.ArtificialNeuralNetworks-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("ALGLIB")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
+  [PluginDependency("HeuristicLab.Modeling-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
+  [PluginDependency("HeuristicLab.Operators.Programmable-3.2")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
+  [PluginDependency("HeuristicLab.Selection-3.2")]
+  [PluginDependency("HeuristicLab.SequentialEngine-3.2")]
   public class HeuristicLabArtificialNeuralNetworks : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Assignment.QAP/3.2/QAPPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Assignment.QAP/3.2/QAPPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Assignment.QAP/3.2/QAPPlugin.cs	(revision 2587)
@@ -26,11 +26,11 @@
 
 namespace HeuristicLab.Assignment.QAP {
-  [ClassInfo(Name = "HeuristicLab.Assignment.QAP-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Assignment.QAP-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Charting-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Permutation-3.2")]
+  [Plugin("HeuristicLab.Assignment.QAP-3.2")]
+  [PluginFile("HeuristicLab.Assignment.QAP-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
+  [PluginDependency("HeuristicLab.Charting-3.2")]
+  [PluginDependency("HeuristicLab.Permutation-3.2")]
   public class QAPPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.BackgroundProcessing/3.2/HeuristicLabBackgroundProcessingPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.BackgroundProcessing/3.2/HeuristicLabBackgroundProcessingPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.BackgroundProcessing/3.2/HeuristicLabBackgroundProcessingPlugin.cs	(revision 2587)
@@ -2,6 +2,6 @@
 
 namespace HeuristicLab.BackgroundProcessing {
-  [ClassInfo(Name = "HeuristicLab.BackgroundProcessing-3.2")]
-  [PluginFile(Filename = "HeuristicLab.BackgroundProcessing-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Plugin("HeuristicLab.BackgroundProcessing-3.2")]
+  [PluginFile("HeuristicLab.BackgroundProcessing-3.2.dll", PluginFileType.Assembly)]
   public class HeuristicLabBackgroundProcessingPlugin : PluginBase { }
 }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.BitVector/3.2/HeuristicLabBitVectorPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.BitVector/3.2/HeuristicLabBitVectorPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.BitVector/3.2/HeuristicLabBitVectorPlugin.cs	(revision 2587)
@@ -29,9 +29,9 @@
   /// Plugin class for HeuristicLab.BitVector plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.BitVector-3.2")]
-  [PluginFile(Filename = "HeuristicLab.BitVector-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Evolutionary-3.2")]
+  [Plugin("HeuristicLab.BitVector-3.2")]
+  [PluginFile("HeuristicLab.BitVector-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Evolutionary-3.2")]
   public class HeuristicLabBitVectorPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.CEDMA.Server/3.3/HeuristicLabCedmaServerPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.CEDMA.Server/3.3/HeuristicLabCedmaServerPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.CEDMA.Server/3.3/HeuristicLabCedmaServerPlugin.cs	(revision 2587)
@@ -26,15 +26,15 @@
 
 namespace HeuristicLab.CEDMA.Server {
-  [ClassInfo(Name = "HeuristicLab.CEDMA.Server-3.3")]
-  [PluginFile(Filename = "HeuristicLab.CEDMA.Server-3.3.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Grid-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Grid.HiveBridge-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling.Database-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Modeling.Database.SQLServerCompact-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Tracing-3.2")]
+  [Plugin("HeuristicLab.CEDMA.Server-3.3")]
+  [PluginFile("HeuristicLab.CEDMA.Server-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Grid-3.2")]
+  [PluginDependency("HeuristicLab.Grid.HiveBridge-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.DataAnalysis-3.2")]
+  [PluginDependency("HeuristicLab.Modeling-3.2")]
+  [PluginDependency("HeuristicLab.Modeling.Database-3.2")]
+  [PluginDependency("HeuristicLab.Modeling.Database.SQLServerCompact-3.2")]
+  [PluginDependency("HeuristicLab.Tracing-3.2")]
   public class HeuristicLabCedmaServerPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.CEDMA.Server/3.3/ServerApplication.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.CEDMA.Server/3.3/ServerApplication.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.CEDMA.Server/3.3/ServerApplication.cs	(revision 2587)
@@ -27,5 +27,5 @@
 
 namespace HeuristicLab.CEDMA.Server {
-  [ClassInfo(Name = "CEDMA", Description = "Cooperative Evolutionary Data Mining.", AutoRestart = true)]
+  [Application("CEDMA", "Cooperative Evolutionary Data Mining.", true)]
   class ServerApplication : ApplicationBase {
     public override void Run() {
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.CEDMA.Server/3.3/SimpleDispatcher.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.CEDMA.Server/3.3/SimpleDispatcher.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.CEDMA.Server/3.3/SimpleDispatcher.cs	(revision 2587)
@@ -117,6 +117,6 @@
       finishedAndDispatchedRuns = new Dictionary<string, List<AlgorithmConfiguration>>();
 
-      DiscoveryService ds = new DiscoveryService();
-      defaultAlgorithms = ds.GetInstances<HeuristicLab.Modeling.IAlgorithm>();
+      
+      defaultAlgorithms = ApplicationManager.Manager.GetInstances<HeuristicLab.Modeling.IAlgorithm>().ToArray();
 
       // PopulateFinishedRuns();
@@ -208,6 +208,5 @@
 
     private IOperator SelectRandomFunctionLibrary() {
-      DiscoveryService ds = new DiscoveryService();
-      var injectors = from injector in ds.GetInstances<FunctionLibraryInjectorBase>()
+      var injectors = from injector in ApplicationManager.Manager.GetInstances<FunctionLibraryInjectorBase>()
                       where injector.GetType().GetCustomAttributes(typeof(SymbolicRegressionFunctionLibraryInjectorAttribute), true).Count() > 0
                       select injector;
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Charting.Data/3.2/HeuristicLabChartingDataPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Charting.Data/3.2/HeuristicLabChartingDataPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Charting.Data/3.2/HeuristicLabChartingDataPlugin.cs	(revision 2587)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Charting.Data {
-  [ClassInfo(Name = "HeuristicLab.Charting.Data-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Charting.Data-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Charting-3.2")]
+  [Plugin("HeuristicLab.Charting.Data-3.2")]
+  [PluginFile("HeuristicLab.Charting.Data-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Charting-3.2")]
   public class HeuristicLabChartingDataPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Charting/3.2/HeuristicLabChartingPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Charting/3.2/HeuristicLabChartingPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Charting/3.2/HeuristicLabChartingPlugin.cs	(revision 2587)
@@ -26,6 +26,6 @@
 
 namespace HeuristicLab.Charting {
-  [ClassInfo(Name = "HeuristicLab.Charting-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Charting-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Plugin("HeuristicLab.Charting-3.2")]
+  [PluginFile("HeuristicLab.Charting-3.2.dll", PluginFileType.Assembly)]
   public class HeuristicLabChartingPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Common.Resources/3.2/HeuristicLabCommonResourcesPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Common.Resources/3.2/HeuristicLabCommonResourcesPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Common.Resources/3.2/HeuristicLabCommonResourcesPlugin.cs	(revision 2587)
@@ -26,6 +26,6 @@
 
 namespace HeuristicLab.Communication.Data {
-  [ClassInfo(Name = "HeuristicLab.Common.Resources-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Common.Resources-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Plugin("HeuristicLab.Common.Resources-3.2")]
+  [PluginFile("HeuristicLab.Common.Resources-3.2.dll", PluginFileType.Assembly)]
   public class HeuristicLabCommonResourcesPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Common/3.2/HeuristicLabCommonPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Common/3.2/HeuristicLabCommonPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Common/3.2/HeuristicLabCommonPlugin.cs	(revision 2587)
@@ -29,6 +29,6 @@
   /// Plugin class for HeuristicLab.Common plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Common-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Common-3.2.dll", Filetype = PluginFileType.Assembly)]
+  [Plugin("HeuristicLab.Common-3.2")]
+  [PluginFile("HeuristicLab.Common-3.2.dll", PluginFileType.Assembly)]
   public class HeuristicLabCommonPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Communication.Data/3.2/HeuristicLabCommunicationDataPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Communication.Data/3.2/HeuristicLabCommunicationDataPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Communication.Data/3.2/HeuristicLabCommunicationDataPlugin.cs	(revision 2587)
@@ -26,11 +26,11 @@
 
 namespace HeuristicLab.Communication.Data {
-  [ClassInfo(Name = "HeuristicLab.Communication.Data-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Communication.Data-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Common-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators.Programmable-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Constraints-3.2")]
+  [Plugin("HeuristicLab.Communication.Data-3.2")]
+  [PluginFile("HeuristicLab.Communication.Data-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common-3.2")]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators.Programmable-3.2")]
+  [PluginDependency("HeuristicLab.Constraints-3.2")]
   public class HeuristicLabCommunicationDataPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Communication.Operators/3.2/HeuristicLab.Communication.Operators-3.2.csproj
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Communication.Operators/3.2/HeuristicLab.Communication.Operators-3.2.csproj	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Communication.Operators/3.2/HeuristicLab.Communication.Operators-3.2.csproj	(revision 2587)
@@ -108,4 +108,5 @@
   <ItemGroup>
     <None Include="HeuristicLab.snk" />
+    <None Include="Properties\AssemblyInfo.frame" />
   </ItemGroup>
   <ItemGroup>
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Communication.Operators/3.2/HeuristicLabCommunicationOperatorsPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Communication.Operators/3.2/HeuristicLabCommunicationOperatorsPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Communication.Operators/3.2/HeuristicLabCommunicationOperatorsPlugin.cs	(revision 2587)
@@ -26,13 +26,13 @@
 
 namespace HeuristicLab.Communication.Operators {
-  [ClassInfo(Name = "HeuristicLab.Communication.Operators-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Communication.Operators-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators.Programmable-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Random-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Communication.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Constraints-3.2")]
+  [Plugin("HeuristicLab.Communication.Operators-3.2")]
+  [PluginFile("HeuristicLab.Communication.Operators-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
+  [PluginDependency("HeuristicLab.Operators-3.2")]
+  [PluginDependency("HeuristicLab.Operators.Programmable-3.2")]
+  [PluginDependency("HeuristicLab.Random-3.2")]
+  [PluginDependency("HeuristicLab.Communication.Data-3.2")]
+  [PluginDependency("HeuristicLab.Constraints-3.2")]
   public class HeuristicLabCommunicationOperatorsPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Constraints/3.2/HeuristicLabConstraintsPlugin.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Constraints/3.2/HeuristicLabConstraintsPlugin.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Constraints/3.2/HeuristicLabConstraintsPlugin.cs	(revision 2587)
@@ -29,8 +29,8 @@
   /// Plugin class for HeuristicLab.Constraints plugin.
   /// </summary>
-  [ClassInfo(Name = "HeuristicLab.Constraints-3.2")]
-  [PluginFile(Filename = "HeuristicLab.Constraints-3.2.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
+  [Plugin("HeuristicLab.Constraints-3.2")]
+  [PluginFile("HeuristicLab.Constraints-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Core-3.2")]
+  [PluginDependency("HeuristicLab.Data-3.2")]
   public class HeuristicLabConstraintsPlugin : PluginBase {
   }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Constraints/3.2/NotConstraintView.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Constraints/3.2/NotConstraintView.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Constraints/3.2/NotConstraintView.cs	(revision 2587)
@@ -58,8 +58,6 @@
     public NotConstraintView() {
       InitializeComponent();
-      DiscoveryService discoveryService = new DiscoveryService();
-      itemTypes = discoveryService.GetTypes(typeof(ConstraintBase));
-      for (int i = 0; i < itemTypes.Length; i++) {
-        subConstraintComboBox.Items.Add(itemTypes[i].Name);
+      foreach (Type itemType in ApplicationManager.Manager.GetTypes(typeof(ConstraintBase))) {
+        subConstraintComboBox.Items.Add(itemType.Name);
       }
       subConstraintComboBox.SelectedIndex = 0;
@@ -130,5 +128,6 @@
         try {
           NotConstraint.SubConstraint = (ConstraintBase)Activator.CreateInstance(itemTypes[subConstraintComboBox.SelectedIndex]);
-        } catch (Exception) {
+        }
+        catch (Exception) {
           NotConstraint.SubConstraint = null;
         }
@@ -144,5 +143,5 @@
     private void UpdateSubConstraintComboBox() {
       subConstraintComboBox.SelectedIndexChanged -= new EventHandler(subConstraintComboBox_SelectedIndexChanged);
-      for (int i = 0 ; i < itemTypes.Length ; i++)
+      for (int i = 0; i < itemTypes.Length; i++)
         if (itemTypes[i].Name.Equals(NotConstraint.SubConstraint.GetType().Name))
           subConstraintComboBox.SelectedIndex = i;
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/ChooseItemDialog.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/ChooseItemDialog.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/ChooseItemDialog.cs	(revision 2587)
@@ -89,11 +89,9 @@
       }
 
-      DiscoveryService discoveryService = new DiscoveryService();
-      foreach (PluginInfo plugin in discoveryService.Plugins) {
+      foreach (IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
         TreeNode pluginNode = new TreeNode(plugin.Name);
         pluginNode.Tag = null;
 
-        Type[] types = discoveryService.GetTypes(itemType, plugin);
-        foreach (Type type in types) {
+        foreach (Type type in ApplicationManager.Manager.GetTypes(itemType, plugin)) {
           if (!type.IsAbstract) {
             TreeNode itemNode = new TreeNode();
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/ChooseOperatorDialog.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/ChooseOperatorDialog.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/ChooseOperatorDialog.cs	(revision 2587)
@@ -70,14 +70,12 @@
       builtinOperatorsTreeView.TreeViewNodeSorter = nodeSorter;
 
-      DiscoveryService discoveryService = new DiscoveryService();
-      PluginInfo[] plugins = discoveryService.Plugins;
-      foreach(PluginInfo plugin in plugins) {
+      foreach (IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
         TreeNode pluginItem = new TreeNode();
         pluginItem.Text = plugin.Name;
         pluginItem.Tag = plugin;
 
-        Type[] operators = discoveryService.GetTypes(typeof(IOperator), plugin);
-        foreach(Type type in operators) {
-          if(!type.IsAbstract) {
+        IEnumerable<Type> operators = ApplicationManager.Manager.GetTypes(typeof(IOperator), plugin);
+        foreach (Type type in operators) {
+          if (!type.IsAbstract) {
             TreeNode operatorItem = new TreeNode();
             operatorItem.Text = type.Name;
@@ -87,5 +85,5 @@
         }
         // add plugin node only if it contains operators
-        if(pluginItem.Nodes.Count > 0) {
+        if (pluginItem.Nodes.Count > 0) {
           builtinOperatorsTreeView.Nodes.Add(pluginItem);
         }
Index: /branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/ChooseTypeDialog.cs
===================================================================
--- /branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/ChooseTypeDialog.cs	(revision 2586)
+++ /branches/PluginInfrastructure Refactoring/HeuristicLab.Core/3.2/ChooseTypeDialog.cs	(revision 2587)
@@ -90,11 +90,9 @@
       }
 
-      DiscoveryService discoveryService = new DiscoveryService();
-      foreach (PluginInfo plugin in discoveryService.Plugins) {
+      foreach (IPluginDescription plugin in ApplicationManager.Manager.Plugins) {
         TreeNode pluginNode = new TreeNode(plugin.Name);
         pluginNode.Tag = null;
 
-        Type[] types = discoveryService.GetTypes(baseType, plugin);
-        foreach (Type type in types) {
+        foreach (Type type in ApplicationManager.Manager.GetTypes(baseType, plugin)) {
           TreeNode itemNode = new TreeNode();
           itemNode.Text = type.Name;
